PF-build.sh 49 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_36
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. #### Start check if OSTYPE is supported
  142. OS_FOUND=$( command -v uname)
  143. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  144. linux*)
  145. TARGET_OS="linux"
  146. ;;
  147. msys*|cygwin*|mingw*)
  148. # or possible 'bash on windows'
  149. TARGET_OS='windows'
  150. ;;
  151. nt|win*)
  152. TARGET_OS='windows'
  153. ;;
  154. *)
  155. TARGET_OS='unknown'
  156. ;;
  157. esac
  158. # Windows
  159. if [ $TARGET_OS == "windows" ]; then
  160. if [ $(uname -m) == "x86_64" ]; then
  161. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  162. Processor="64"
  163. elif [ $(uname -m) == "i386" ]; then
  164. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  165. Processor="32"
  166. else
  167. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  168. echo "Please refer to the notes of build.sh$(tput sgr0)"
  169. exit 1
  170. fi
  171. # Linux
  172. elif [ $TARGET_OS == "linux" ]; then
  173. if [ $(uname -m) == "x86_64" ]; then
  174. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  175. Processor="64"
  176. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  177. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  178. Processor="32"
  179. else
  180. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  181. echo "Please refer to the notes of build.sh$(tput sgr0)"
  182. exit 1
  183. fi
  184. else
  185. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  186. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  187. echo "Read the notes of build.sh$(tput sgr0)"
  188. exit 1
  189. fi
  190. sleep 2
  191. #### End check if OSTYPE is supported
  192. #### Prepare bash environment and check if wget, zip and other needed things are available
  193. # Check wget
  194. if ! type wget > /dev/null; then
  195. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  196. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  197. exit 2
  198. fi
  199. # Check for zip
  200. if ! type zip > /dev/null; then
  201. if [ $TARGET_OS == "windows" ]; then
  202. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  203. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  204. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  205. echo "Run git Bash under Administrator privilege and"
  206. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  207. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  208. exit 3
  209. elif [ $TARGET_OS == "linux" ]; then
  210. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  211. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  212. #sudo apt-get update && apt-get install zip
  213. exit 3
  214. fi
  215. fi
  216. # Check python ... needed during language build
  217. if ! type python > /dev/null; then
  218. if [ $TARGET_OS == "windows" ]; then
  219. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  220. exit 4
  221. elif [ $TARGET_OS == "linux" ]; then
  222. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  223. echo "As Python 2.x will not be maintained from 2020 please,"
  224. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  225. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  226. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  227. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  228. exit 4
  229. fi
  230. fi
  231. # Check gawk ... needed during language build
  232. if ! type gawk > /dev/null; then
  233. if [ $TARGET_OS == "linux" ]; then
  234. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  235. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  236. #sudo apt-get update && apt-get install gawk
  237. exit 4
  238. fi
  239. fi
  240. #### End prepare bash / Linux environment
  241. #### Set build environment
  242. ARDUINO_ENV="1.8.5"
  243. BUILD_ENV="1.0.6"
  244. BOARD="prusa_einsy_rambo"
  245. BOARD_PACKAGE_NAME="PrusaResearch"
  246. BOARD_VERSION="1.0.3"
  247. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  248. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  249. BOARD_FILENAME="prusa3dboards"
  250. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  251. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  252. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  253. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  254. LIB="PrusaLibrary"
  255. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  256. # List few useful data
  257. echo
  258. echo "Script path :" $SCRIPT_PATH
  259. echo "OS :" $OS
  260. echo "OS type :" $TARGET_OS
  261. echo ""
  262. echo "Arduino IDE :" $ARDUINO_ENV
  263. echo "Build env :" $BUILD_ENV
  264. echo "Board :" $BOARD
  265. echo "Package name:" $BOARD_PACKAGE_NAME
  266. echo "Board v. :" $BOARD_VERSION
  267. echo "Specific Lib:" $LIB
  268. echo ""
  269. #### Start prepare building environment
  270. #Check if build exists and creates it if not
  271. if [ ! -d "../PF-build-dl" ]; then
  272. mkdir ../PF-build-dl || exit 5
  273. fi
  274. cd ../PF-build-dl || exit 6
  275. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  276. # Check if PF-build-env-<version> exists and downloads + creates it if not
  277. # The build environment is based on the supported Arduino IDE portable version with some changes
  278. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  279. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  280. mkdir ../PF-build-env-$BUILD_ENV
  281. sleep 5
  282. fi
  283. # Download and extract supported Arduino IDE depending on OS
  284. # Windows
  285. if [ $TARGET_OS == "windows" ]; then
  286. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  287. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  288. sleep 2
  289. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  290. echo "$(tput sgr 0)"
  291. fi
  292. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  293. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  294. sleep 2
  295. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  296. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  297. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  298. echo "$(tput sgr0)"
  299. fi
  300. fi
  301. # Linux
  302. if [ $TARGET_OS == "linux" ]; then
  303. # 32 or 64 bit version
  304. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  305. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  306. sleep 2
  307. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  308. echo "$(tput sgr 0)"
  309. fi
  310. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  311. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  312. sleep 2
  313. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  314. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  315. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  316. echo "$(tput sgr0)"
  317. fi
  318. fi
  319. # Make Arduino IDE portable
  320. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  321. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  322. fi
  323. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  324. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  325. fi
  326. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  327. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  328. fi
  329. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  330. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  331. fi
  332. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  333. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  334. fi
  335. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  336. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  337. fi
  338. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  339. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  340. fi
  341. # Change Arduino IDE preferences
  342. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  343. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  344. sleep 2
  345. echo "update.check"
  346. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  347. echo "board"
  348. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  349. echo "editor.linenumbers"
  350. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  351. echo "boardsmanager.additional.urls"
  352. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  353. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  354. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  355. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  356. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  357. echo "$(tput sgr0)"
  358. fi
  359. # Download and extract Prusa Firmware related parts
  360. # Download and extract PrusaResearchRambo board
  361. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  362. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  363. sleep 2
  364. wget $BOARD_FILE_URL || exit 9
  365. fi
  366. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  367. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  368. sleep 2
  369. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  370. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  371. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  372. fi
  373. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  374. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  375. fi
  376. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  377. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  378. fi
  379. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  380. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  381. fi
  382. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  383. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  384. echo "$(tput sgr 0)"
  385. fi
  386. # Download and extract Prusa Firmware specific library files
  387. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  388. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  389. sleep 2
  390. wget $PF_BUILD_FILE_URL || exit 11
  391. echo "$(tput sgr 0)"
  392. fi
  393. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  394. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  395. sleep 2
  396. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  397. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  398. echo "$(tput sgr0)"
  399. fi
  400. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  401. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  402. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  403. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  404. sleep 2
  405. fi
  406. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  407. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  408. sleep 2
  409. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  410. sleep 2
  411. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  412. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  413. echo "$(tput sgr0)"
  414. fi
  415. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  416. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  417. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  418. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  419. sleep 2
  420. echo "$(tput sgr0)"
  421. exit 13
  422. fi
  423. #### End prepare building
  424. #### Start
  425. cd $SCRIPT_PATH
  426. # Check if git is available
  427. if type git > /dev/null; then
  428. git_available="1"
  429. fi
  430. while getopts v:l:d:b:o:c:p:n:m:g:?h flag
  431. do
  432. case "${flag}" in
  433. v) variant_flag=${OPTARG};;
  434. l) language_flag=${OPTARG};;
  435. d) devel_flag=${OPTARG};;
  436. b) build_flag=${OPTARG};;
  437. o) output_flag=${OPTARG};;
  438. c) clean_flag=${OPTARG};;
  439. p) prusa_flag=${OPTARG};;
  440. n) new_build_flag=${OPTARG};;
  441. m) mk404_flag=${OPTARG};;
  442. g) grafics_flag=${OPTARG};;
  443. ?) help_flag=1;;
  444. h) help_flag=1;;
  445. esac
  446. done
  447. #echo "variant_flag: $variant_flag";
  448. #echo "language_flag: $language_flag";
  449. #echo "devel_flag: $devel_flag";
  450. #echo "build_flag: $build_flag";
  451. #echo "output_flag: $output_flag";
  452. #echo "help_flag: $help_flag"
  453. #echo "clean_flag: $clean_flag"
  454. #echo "prusa_flag: $prusa_flag"
  455. #echo "new_build_flag: $new_build_flag"
  456. #
  457. # '?' 'h' argument usage and help
  458. if [ "$help_flag" == "1" ] ; then
  459. echo "***************************************"
  460. echo "* PF-build.sh Version: 1.0.6-Build_33 *"
  461. echo "***************************************"
  462. echo "Arguments:"
  463. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  464. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  465. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  466. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  467. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  468. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  469. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  470. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  471. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  472. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  473. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  474. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  475. echo
  476. echo "Brief USAGE:"
  477. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n] [-m]"
  478. echo
  479. echo "Example:"
  480. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  481. echo " Will build all variants as multi language and final GOLD version"
  482. echo
  483. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  484. echo " Will build MK3S multi language final GOLD firmware "
  485. echo " with current commit count number and output extra information,"
  486. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  487. echo
  488. exit
  489. fi
  490. #
  491. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  492. if [ -z "$variant_flag" ] ; then
  493. # Select which variant of the Prusa Firmware will be compiled, like
  494. PS3="Select a variant: "
  495. while IFS= read -r -d $'\0' f; do
  496. options[i++]="$f"
  497. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  498. select opt in "${options[@]}" "All" "Quit"; do
  499. case $opt in
  500. *.h)
  501. VARIANT=$(basename "$opt" ".h")
  502. VARIANTS[i++]="$opt"
  503. break
  504. ;;
  505. "All")
  506. VARIANT="All"
  507. VARIANTS=${options[*]}
  508. break
  509. ;;
  510. "Quit")
  511. echo "You chose to stop"
  512. exit 20
  513. ;;
  514. *)
  515. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  516. ;;
  517. esac
  518. done
  519. else
  520. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  521. VARIANTS=$variant_flag
  522. elif [ "$variant_flag" == "All" ] ; then
  523. while IFS= read -r -d $'\0' f; do
  524. options[i++]="$f"
  525. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  526. VARIANT="All"
  527. VARIANTS=${options[*]}
  528. else
  529. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  530. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  531. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  532. echo "$(tput sgr0)"
  533. exit 21
  534. fi
  535. fi
  536. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  537. #Check default language mode
  538. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  539. if [ -z "$language_flag" ] ; then
  540. PS3="Select a language: "
  541. echo
  542. echo "Which lang-build do you want?"
  543. select yn in "Multi languages" "English only"; do
  544. case $yn in
  545. "Multi languages")
  546. LANGUAGES="ALL"
  547. break
  548. ;;
  549. "English only")
  550. LANGUAGES="EN_ONLY"
  551. break
  552. ;;
  553. *)
  554. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  555. ;;
  556. esac
  557. done
  558. else
  559. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  560. LANGUAGES=$language_flag
  561. else
  562. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  563. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  564. exit 22
  565. fi
  566. fi
  567. #Check if DEV_STATUS is selected via argument '-d'
  568. if [ ! -z "$devel_flag" ] ; then
  569. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  570. DEV_STATUS_SELECTED=$devel_flag
  571. else
  572. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  573. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  574. exit 23
  575. fi
  576. fi
  577. #Check if Build is selected via argument '-b'
  578. if [ ! -z "$build_flag" ] ; then
  579. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  580. echo "Build changed to $build_flag"
  581. BUILD=$(git rev-list --count HEAD)
  582. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  583. BUILD=$build_flag
  584. else
  585. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  586. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  587. exit 24
  588. fi
  589. echo "New Build number is: $BUILD"
  590. fi
  591. # check if script has been started with arguments
  592. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  593. OUTPUT=1
  594. else
  595. OUTPUT=0
  596. fi
  597. #echo "Output is:" $OUTPUT
  598. #Check git branch has changed
  599. if [ ! -z "git_available" ]; then
  600. BRANCH=""
  601. CLEAN_PF_FW_BUILD=0
  602. else
  603. BRANCH=$(git branch --show-current)
  604. echo "Current branch is:" $BRANCH
  605. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  606. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  607. echo "created PF-build.branch file"
  608. else
  609. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  610. echo "Previous branch was:" $PRE_BRANCH
  611. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  612. CLEAN_PF_FW_BUILD=1
  613. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  614. fi
  615. fi
  616. fi
  617. #Set BUILD_ENV_PATH
  618. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
  619. BUILD_ENV_PATH="$( pwd -P )"
  620. cd ../..
  621. #Checkif BUILD_PATH exists and if not creates it
  622. if [ ! -d "Prusa-Firmware-build" ]; then
  623. mkdir Prusa-Firmware-build || exit 26
  624. fi
  625. #Set the BUILD_PATH for Arduino IDE
  626. cd Prusa-Firmware-build || exit 27
  627. BUILD_PATH="$( pwd -P )"
  628. #Check git branch has changed
  629. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  630. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  631. rm -r *
  632. else
  633. echo "Nothing to clean up"
  634. fi
  635. for v in ${VARIANTS[*]}
  636. do
  637. VARIANT=$(basename "$v" ".h")
  638. PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  639. # Find firmware version in Configuration.h file and use it to generate the hex filename
  640. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  641. if [ -z "$BUILD" ] ; then
  642. # Find build version in Configuration.h file and use it to generate the hex filename
  643. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  644. else
  645. # Find and replace build version in Configuration.h file
  646. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  647. echo "Original build number: $BUILD_ORG"
  648. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  649. fi
  650. # Check if the motherboard is an EINSY and if so only one hex file will generated
  651. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  652. # Check development status
  653. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  654. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  655. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  656. DEV_STATUS="RC"
  657. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  658. DEV_STATUS="ALPHA"
  659. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  660. DEV_STATUS="BETA"
  661. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  662. DEV_STATUS="DEVEL"
  663. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  664. DEV_STATUS="DEBUG"
  665. else
  666. DEV_STATUS="UNKNOWN"
  667. echo
  668. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  669. PS3="Select YES only if source code is tested and trusted: "
  670. select yn in "Yes" "No"; do
  671. case $yn in
  672. Yes)
  673. DEV_STATUS="GOLD"
  674. DEV_STATUS_SELECTED="GOLD"
  675. break
  676. ;;
  677. No)
  678. DEV_STATUS="UNKNOWN"
  679. DEV_STATUS_SELECTED="UNKNOWN"
  680. break
  681. ;;
  682. *)
  683. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  684. ;;
  685. esac
  686. done
  687. fi
  688. else
  689. DEV_STATUS=$DEV_STATUS_SELECTED
  690. fi
  691. #Prepare hex files folders
  692. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  693. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  694. fi
  695. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  696. #Check if exactly the same hexfile already exists
  697. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  698. echo ""
  699. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  700. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  701. if [ $OUTPUT == "1" ] ; then
  702. read -t 10 -p "Press Enter to continue..."
  703. fi
  704. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  705. echo ""
  706. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  707. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  708. if [ $OUTPUT == "1" ] ; then
  709. read -t 10 -p "Press Enter to continue..."
  710. fi
  711. fi
  712. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  713. echo ""
  714. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  715. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  716. if [ $OUTPUT == "1" ] ; then
  717. read -t 10 -p "Press Enter to continue..."
  718. fi
  719. fi
  720. #List some useful data
  721. echo "$(tput setaf 2)$(tput setab 7) "
  722. echo "Printer :" $PRINTER
  723. echo "Variant :" $VARIANT
  724. echo "Firmware :" $FW
  725. echo "Build # :" $BUILD
  726. echo "Dev Check :" $DEV_CHECK
  727. echo "DEV Status :" $DEV_STATUS
  728. echo "Motherboard:" $MOTHERBOARD
  729. echo "Languages :" $LANGUAGES
  730. echo "Hex-file Folder:" $OUTPUT_FOLDER
  731. echo "$(tput sgr0)"
  732. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  733. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  734. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  735. else
  736. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  737. if [ $OUTPUT == "1" ] ; then
  738. read -t 10 -p "Press Enter to continue..."
  739. fi
  740. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  741. fi
  742. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  743. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  744. # set FW_REPOSITORY
  745. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  746. #Prepare English only or multi-language version to be build
  747. if [ $LANGUAGES == "EN_ONLY" ]; then
  748. echo " "
  749. echo "English only language firmware will be built"
  750. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  751. echo " "
  752. else
  753. echo " "
  754. echo "Multi-language firmware will be built"
  755. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  756. echo " "
  757. fi
  758. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  759. # if [ $TARGET_OS == "windows" ]; then
  760. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  761. # fi
  762. #### End of Prepare building
  763. #### Start building
  764. export ARDUINO=$BUILD_ENV_PATH
  765. #echo $BUILD_ENV_PATH
  766. #export BUILDER=$ARDUINO/arduino-builder
  767. echo
  768. #read -t 5 -p "Press Enter..."
  769. echo
  770. echo "Start to build Prusa Firmware ..."
  771. echo "Using variant $VARIANT$(tput setaf 3)"
  772. if [ $OUTPUT == "1" ] ; then
  773. sleep 2
  774. fi
  775. #New fresh PF-Firmware-build
  776. if [ "$new_build_flag" == "1" ]; then
  777. rm -r -f $BUILD_PATH/* || exit 36
  778. fi
  779. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  780. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  781. echo "$(tput sgr 0)"
  782. if [ $LANGUAGES == "ALL" ]; then
  783. echo "$(tput setaf 2)"
  784. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  785. echo "$(tput sgr 0)"
  786. if [ $OUTPUT == "1" ] ; then
  787. sleep 2
  788. fi
  789. cd $SCRIPT_PATH/lang
  790. echo "$(tput setaf 3)"
  791. ./config.sh || exit 31
  792. echo "$(tput sgr 0)"
  793. # Check if previous languages and firmware build exist and if so clean them up
  794. if [ -f "lang_en.tmp" ]; then
  795. echo ""
  796. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  797. if [ $OUTPUT == "1" ] ; then
  798. read -t 10 -p "Press Enter to continue..."
  799. fi
  800. echo "$(tput setaf 3)"
  801. ./lang-clean.sh
  802. echo "$(tput sgr 0)"
  803. fi
  804. if [ -f "progmem.out" ]; then
  805. echo ""
  806. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  807. if [ $OUTPUT == "1" ] ; then
  808. read -t 10 -p "Press Enter to continue..."
  809. fi
  810. echo "$(tput setaf 3)"
  811. ./fw-clean.sh
  812. echo "$(tput sgr 0)"
  813. fi
  814. # build languages
  815. echo "$(tput setaf 3)"
  816. ./lang-build.sh || exit 32
  817. # Combine compiled firmware with languages
  818. ./fw-build.sh || exit 33
  819. cp not_tran.txt not_tran_$VARIANT.txt
  820. cp not_used.txt not_used_$VARIANT.txt
  821. echo "$(tput sgr 0)"
  822. # Check if the motherboard is an EINSY and if so only one hex file will generated
  823. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  824. # If the motherboard is an EINSY just copy one hexfile
  825. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  826. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  827. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  828. else
  829. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  830. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  831. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  832. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  833. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  834. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  835. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  836. if [ $TARGET_OS == "windows" ]; then
  837. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  838. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  839. elif [ $TARGET_OS == "linux" ]; then
  840. if [ ! -z "$mk404_flag" ]; then
  841. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  842. fi
  843. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  844. fi
  845. fi
  846. # Cleanup after build
  847. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  848. echo "$(tput setaf 3)"
  849. ./fw-clean.sh || exit 34
  850. ./lang-clean.sh || exit 35
  851. echo "$(tput sgr 0)"
  852. fi
  853. else
  854. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  855. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  856. fi
  857. # Cleanup Firmware
  858. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  859. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  860. fi
  861. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  862. then
  863. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  864. fi
  865. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  866. then
  867. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  868. fi
  869. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  870. then
  871. rm $SCRIPT_PATH/lang/not_tran.txt
  872. fi
  873. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  874. then
  875. rm $SCRIPT_PATH/lang/not_used.txt
  876. fi
  877. #New fresh PF-Firmware-build
  878. if [ "$new_build_flag" == "1" ]; then
  879. rm -r -f $BUILD_PATH/* || exit 36
  880. fi
  881. # Restore files to previous state
  882. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  883. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  884. if [ ! -z "$BUILD_ORG" ] ; then
  885. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  886. fi
  887. echo $MULTI_LANGUAGE_CHECK
  888. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  889. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  890. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  891. if [ $OUTPUT == "1" ] ; then
  892. sleep 5
  893. fi
  894. done
  895. # Switch to hex path and list build files
  896. cd $SCRIPT_PATH
  897. echo "$(tput setaf 2) "
  898. echo " "
  899. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  900. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  901. #### End building
  902. ls
  903. #### Run MK404 sim
  904. if [ ! -z "$mk404_flag" ]; then
  905. ./MK404-build.sh
  906. if [ "$mk404_flag" == "2" ]; then
  907. PRINTER="${PRINTER}MMU2"
  908. fi
  909. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  910. PRINTER="${PRINTER}_mR13"
  911. fi
  912. if [ ! -z "$grafics_flag" ]; then
  913. options="--colour-extrusion --extrusion Quad_HR -g "
  914. if [ "$grafics_flag" == "1" ]; then
  915. options="${options}lite"
  916. else
  917. options="${options}fancy"
  918. fi
  919. fi
  920. echo "Printer: $PRINTER"
  921. echo "Options: $options"
  922. cd ../MK404/build
  923. ./MK404 Prusa_$PRINTER -s --terminal $options -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  924. fi